module Grammar where

--import Prelude hStringing (Either, Maybe)




data Grammar = Grammar {
	mainRule :: String,
	skipped :: [String],
	delimiters :: [String],
	rules :: [(String, ParseRule)]
	}


data ParseRule
	= Syntax SyntaxRule
	| Token TokenType String


data TokenType = Bounded | Greedy

data SyntaxRule
	= Either     [SyntaxRule]
	| Sequence   [SyntaxRule]

	| Maybe       SyntaxRule
	| ZeroOrMore  SyntaxRule
	| OneOrMore   SyntaxRule

	| Rule         String
	| DirectToken  String


